#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int M, m;
struct node {
    int mn, cnt;
};
vector<node> t;
vector<int> fl;
vector<int> b;

node merge(node v1, node v2) {
    auto [mn1, c1] = v1;
    auto [mn2, c2] = v2;
    if (mn1 == mn2) {
        return {mn1, c1 + c2};
    }
    if (mn1 < mn2)return v1;
    return v2;
}

void build() {
    M = 1;
    while (M <= m)M *= 2;
    t.resize(2 * M, {0, 0});
    fl.resize(2 * M);
    for (int i = 1; i < m; ++i) {
        t[i + M] = {0, b[i] - b[i-1]};
    }
    for (int i = M - 1; i > 0; --i) {
        t[i] = merge(t[i * 2], t[i * 2 + 1]);
    }
}

void push(int v) {
    for (int u = v * 2; u <= v * 2 + 1; u++)
        fl[u] += fl[v], t[u].mn += fl[v];
    fl[v] = 0;
}

void upd(int lq, int rq, int x, int v = 1, int l = 0, int r = M) {
    if (rq <= l || r <= lq)return;
    if (lq <= l && r <= rq) {
        t[v].mn += x;
        fl[v] += x;
        return;
    }
    push(v);
    int mid = (l + r) / 2;
    upd(lq, rq, x, v * 2, l, mid);
    upd(lq, rq, x, v * 2 + 1, mid, r);
    t[v] = merge(t[v * 2], t[v * 2 + 1]);
}

int get0(int lq, int rq, int v = 1, int l = 0, int r = M) {
    if (rq <= l || r <= lq)return 0;
    if (lq <= l && r <= rq) {
        if (t[v].mn == 0)return t[v].cnt;
        return 0;
    }
    push(v);
    int mid = (l + r) / 2;
    return get0(lq, rq, v * 2, l, mid) + get0(lq, rq, v * 2 + 1, mid, r);
}

struct p {
    int x, y1, y2, t;
};

bool cmp(p A, p B) {
    return A.x < B.x;
}

void solve() {
    int k, n;
    cin >> k >> n;
    vector<int> a(n);
    vector<char> type(n);
    for (int i = 0; i < n; ++i) {
        cin >> type[i] >> a[i];
    }
    /*
     N - i+1
     S - i-1
     E - j+1
     W - j-1
     */
    vector<tuple<int, int, int, int>> c;
    int ans = 0;
    int x = 0, y = 0;
    map<int, int> wy;
    for (int i = 0; i < n; ++i) {
        int x2 = x, y2 = y;
        int X1, Y1, X2, Y2;
        if (type[i] == 'E') {
            x2 += a[i];
            X1 = x, Y1 = y, X2 = x2 + k, Y2 = y2 + k;
        }
        if (type[i] == 'N') {
            y2 += a[i];
            X1 = x, Y1 = y, X2 = x2 + k, Y2 = y2 + k;
        }
        if (type[i] == 'W') {
            x2 -= a[i];
            X1 = x2, Y1 = y2, X2 = x + k, Y2 = y + k;
        }
        if (type[i] == 'S') {
            y2 -= a[i];
            X1 = x2, Y1 = y2, X2 = x + k, Y2 = y + k;
        }
        wy[Y1] = 0, wy[Y2] = 0;
        c.push_back({X1, Y1, X2, Y2});
        x = x2, y = y2;
    }
    vector<p> d;
    int mn = inf, mx = -inf;
    for (auto [x1, y1, x2, y2]: c) {
        d.push_back({x1, y1, y2, 1});
        d.push_back({x2, y1, y2, -1});
        mn = min(mn, y1);
        mx = max(mx, y2);
    }
    sort(all(d), cmp);
    m = 0;
    for (auto &[Y, val]: wy) b.push_back(Y), val = m++;
    build();
    int i = 0;
    while (i < sz(d)) {
        int i1 = i;
        while (i < sz(d) && d[i].x == d[i1].x) {
            int l = wy[d[i].y1] + 1, r = wy[d[i].y2] + 1, ty = d[i].t;
            upd(l, r, ty);
            i++;
        }
        if (i < sz(d)) {
            int yy = get0(0, m);
            ans += (mx - mn - yy + 1) * (d[i].x - d[i-1].x);
        }
    }
    cout<<ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
/*
 1 5
 E 2
 N 2
 W 4
 S 4
 E 4

 3 4
 W 2
 N 1
 W 1
 N 2
 */